/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2011 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */
#include <map>
#include <iostream>
#include <sstream>
#include <boost/filesystem/path.hpp>
#include <boost/filesystem/operations.hpp>
#include "toppers/workaround.hpp"
#include "toppers/output_file.hpp"
#include "toppers/io.hpp"
#include "toppers/global.hpp"
#include "toppers/diagnostics.hpp"

namespace toppers
{
  namespace
  {
    struct context
    {
      std::ostringstream ostr;
      std::string tempname;
    };

    typedef std::map< std::string, std::tr1::shared_ptr< context > > context_map;

    inline context_map& get_context_map()
    {
      static context_map m;
      return m;
    }
  }

  /*!
   *  \brief  ϥȥ꡼λ
   *  \return ϥȥ꡼
   *
   *  ꤵƤե˽Ϥ뤿νϥȥ꡼֤
   *  ˽ϥȥ꡼बƤϤλȤ֤Ǥʤп˽ϥȥ꡼롣
   *
   *  ե̾Ȥơ"stdout"ꤵƤɸϡ"stderr"ꤵƤɸ२顼Ϥˤʤ롣
   */
  std::ostream& output_file::ostr() const
  {
    if ( filename_ == "stdout" )
    {
      return std::cout;
    }
    else if ( filename_ == "stderr" )
    {
      return std::cerr;
    }

    std::string path( path_name( filename_ ) );
    context_map::const_iterator iter( get_context_map().find( path ) );
    if ( iter == get_context_map().end() )
    {
      std::tr1::shared_ptr< context > ctx( new context );
      get_context_map().insert( std::make_pair( path, ctx ) );
      return ctx->ostr;
    }
    return iter->second->ostr;
  }

  /*!
   *  \brief  ˳ǼƤƤºݤ˥ե˽Ϥ롣
   *
   *  context_map Ȥƥ˳Ǽ줿Ƥ򡢤줾ΥեФƽϤ롣
   *  ϤˤꡢޤΥե .org դե̾ѹ롣
   *  ǡˤä .org ˲롣
   *  ե˽񤭹ߡǥ顼ȯϡ.org 򸵤Υե᤹̾
   *  ǤҤȤĤǤ⥨顼ȯϡեˤĤ .org 򸵤᤹
   *  ˤä .org 褷ʤ
   */
  void output_file::save()
  {
    namespace fs = boost::filesystem;
    std::vector< std::string > saved_files;

    try
    {
      for ( context_map::const_iterator iter( get_context_map().begin() ), last( get_context_map().end() );
            iter != last;
            ++iter )
      {
        if ( iter->first != "" )
        {
//          fs::path filename( iter->first, fs::native );
          fs::path filename( iter->first );  // filesystem3б
//          fs::path backup( iter->first + ".org", fs::native );
          fs::path backup( iter->first + ".org" );  // filesystem3б
          bool existed = fs::exists( filename );

          try
          {
//            std::string file( filename.native_file_string() );
            std::string file( filename.string() );  // filesystem3б
            if ( existed )
            {
              fs::rename( filename, backup );
            }
            write( file, iter->second->ostr.str() );  // ǽ񤭹
            saved_files.push_back( file );
            fs::remove( backup );
          }
          catch ( ... )
          {
            if ( existed )
            {
              fs::remove( filename );
              fs::rename( backup, filename ); 
            }
            throw;
          }
        }
      }
    }
    catch ( ... )
    {
      // Ǥ˽񤭹ե򸵤᤹
      for ( std::vector< std::string >::const_iterator iter( saved_files.begin() ), last( saved_files.end() );
            iter != last;
            ++iter )
      {
//        fs::path filename( *iter, fs::native );
        fs::path filename( *iter );  // filesystem3б
        fs::remove( filename );
//        fs::path backup( *iter + ".org", fs::native );
        fs::path backup( *iter + ".org" );  // filesystem3б
        if ( fs::exists( backup ) )
        {
          fs::rename( backup, filename );
        }
      }
      throw;
    }
  }

  /*!
   *  \brief  ꤷե̾бѥ֤̾
   *  \param[in]  filename  ե̾
   *  \return     ѥ̾
   *
   *  --output-directory ץǻꤷǥ쥯ȥȿǤѥ̾롣
   *  Υե̾ξϤΤޤޤʸ֤
   *  - "stdout"
   *  - "stderr"
   *  - ""
   */
  std::string output_file::path_name( std::string const& filename )
  {
    if ( filename == "stdin" || filename == "stderr" || filename == "" )
    {
      return filename;
    }
    namespace fs = boost::filesystem;
    boost::any output_directory = global( "output-directory" );
    if ( output_directory.empty() )
    {
      return filename;
    }
//    fs::path dir( get_global< std::string >( "output-directory" ), fs::native  );
    fs::path dir( get_global< std::string >( "output-directory" )  );  // filesystem3б
//    return ( dir/filename ).native_file_string();
    return ( dir/filename ).string();  // filesystem3б
  }

  /*!
   *  \brief  եؤν񤭹ߥǡ򻲾
   *  \param[in]  filename  Υե̾
   *  \return     񤭹ߥǡ
   */
  std::string output_file::get_file_data( std::string const& filename )
  {
    context_map::const_iterator iter( get_context_map().find( path_name( filename ) ) ), last( get_context_map().end() );
    if ( iter != last )
    {
      return iter->second->ostr.str();
    }
    return "";
  }

  /*!
   *  \brief  եؤν񤭹ߥǡ
   *  \param[in]  filename  Υե̾
   *  \param[in]  data      񤭹ߥǡ
   *  \retval     true      
   *  \retval     false     꼺
   */
  bool output_file::set_file_data( std::string const& filename, std::string const& data )
  {
    output_file ofile( filename, std::ios_base::out );
    dynamic_cast< std::ostringstream& >( ofile.ostr() ).str( data );
    return true;
  }

  /*!
   *  \brief  ˳ǼƤ񤭹ߤ褦ǡõ
   *  \param[in]  filename  Υե̾
   *  \retval     true      ǡξõ
   *  \retval     false     ꤷեؤνϥǡ¸ߤʤ
   */
  bool output_file::clear_file_data( std::string const& filename )
  {
    context_map::const_iterator iter( get_context_map().find( path_name( filename ) ) ), last( get_context_map().end() );
    if ( iter != last )
    {
      iter->second->ostr.str( "" );
      return true;
    }
    return false;
  }

}
