/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2010-2011 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *   ܥեȥѤΤޤࡥʲƱˤѡʣ
 *   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *       ˴ޤޤƤ뤳ȡ
 *   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *       ѤǤǺۤˤϡۤȼɥȡ
 *       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *       ̵ݾڵǺܤ뤳ȡ
 *   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *       ѤǤʤǺۤˤϡΤ줫ξ
 *       ȡ
 *     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *         𤹤뤳ȡ
 *   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *       դ뤳ȡ
 *  
 *   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *   TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *   ФŬޤơʤݾڤԤʤޤܥեȥ
 *   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *   Ǥʤ
 *
 */

/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tDriverTaskBody_template.c => src/tDriverTaskBody.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * gyroOffset       uint16_t         ATTR_gyroOffset 
 * speed            int16_t          VAR_speed       
 * turn             int16_t          VAR_turn        
 *
 * ƤӸؿ #_TCPF_#
 * call port : cLeftMotor  signature: sMotor context: task
 *   void           cLeftMotor_setPWM( int8_t pwm, bool_t brakeMode );
 *   void           cLeftMotor_setRevolution( int32_t revolution );
 *   void           cLeftMotor_getRevolution( int32_t* revolution );
 * call port : cRightMotor  signature: sMotor context: task
 *   void           cRightMotor_setPWM( int8_t pwm, bool_t brakeMode );
 *   void           cRightMotor_setRevolution( int32_t revolution );
 *   void           cRightMotor_getRevolution( int32_t* revolution );
 * call port : cGyroSensor  signature: sSensor context: task
 *   void           cGyroSensor_getValue( uint16_t* value );
 * call port : cBattery  signature: sBattery context: task
 *   uint16_t       cBattery_getBatteryVoltage( );
 * call port : cBalancer  signature: sBalancer context: task
 *   void           cBalancer_control( int16_t forward, int16_t turn, uint16_t gyro, uint16_t gyroOffset, int32_t leftRevolution, int32_t rightRevolution, uint16_t battery, int8_t* pwm_l, int8_t* pwm_r );
 *
 * #[</PREAMBLE>]# */

#include "tDriverTaskBody_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tDriverTaskBody_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
	uint16_t gyro;          // 㥤
	int32_t rev_l, rev_r;  // ⡼βž
	int8_t  pwm_l, pwm_r;  // ⡼ͿPWM

	/*
	 *  㥤ͤμ
	 */
	cGyroSensor_getValue(&gyro);

	/*
	 *  ⡼βž
	 */
	cLeftMotor_getRevolution(&rev_l);
	cRightMotor_getRevolution(&rev_r);
	
	/*
	 *  ΩΤPWMͤη׻
	 */
	cBalancer_control(VAR_speed,
					  VAR_turn,
					  gyro,
					  ATTR_gyroOffset,
					  rev_l,
					  rev_r,
					  cBattery_getBatteryVoltage(),
					  &pwm_l,
					  &pwm_r);

	/*
	 *  PWMͤ⡼˥å
	 */
	cLeftMotor_setPWM(pwm_l, 1);
	cRightMotor_setPWM(pwm_r, 1);
}

/* #[<ENTRY_PORT>]# eDrive
 * entry port: eDrive
 * signature:  sDrive
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eDrive_setTurn
 * name:         eDrive_setTurn
 * global_name:  tDriverTaskBody_eDrive_setTurn
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eDrive_setTurn(int16_t turn)
{
	/*
	 *  turnͤ򹹿
	 */
	VAR_turn = turn;
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
