/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *   Copyright (C) 2010-2011 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *   ܥեȥѤΤޤࡥʲƱˤѡʣ
 *   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *       ˴ޤޤƤ뤳ȡ
 *   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *       ѤǤǺۤˤϡۤȼɥȡ
 *       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *       ̵ݾڵǺܤ뤳ȡ
 *   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *       ѤǤʤǺۤˤϡΤ줫ξ
 *       ȡ
 *     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *         𤹤뤳ȡ
 *   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *       դ뤳ȡ
 *
 *   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *   TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *   ФŬޤơʤݾڤԤʤޤܥեȥ
 *   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *   Ǥʤ
 *
 */
/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tButtonBody_inline_template.h => src/tButtonBody_inline.h
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * threshold        int32_t          ATTR_threshold  
 * button           uint8_t          VAR_button      
 * count            int32_t          VAR_count       
 * preState         uint8_t          VAR_preState    
 *
 * #[</PREAMBLE>]# */

#define BUTTON_ENTER 0x01
#define BUTTON_STOP  0x02
#define BUTTON_RUN   0x04
#define BUTTON_EXIT  0x08

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eButton
 * entry port: eButton
 * signature:  sButton
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eButton_isENTERButton
 * name:         eButton_isENTERButton
 * global_name:  tButtonBody_eButton_isENTERButton
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isENTERButton()
{
    return ((VAR_button & BUTTON_ENTER) == BUTTON_ENTER);
}

/* #[<ENTRY_FUNC>]# eButton_isRUNButton
 * name:         eButton_isRUNButton
 * global_name:  tButtonBody_eButton_isRUNButton
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isRUNButton()
{
    return ((VAR_button & BUTTON_RUN) == BUTTON_RUN);
}

/* #[<ENTRY_FUNC>]# eButton_isSTOPButton
 * name:         eButton_isSTOPButton
 * global_name:  tButtonBody_eButton_isSTOPButton
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isSTOPButton()
{
    return ((VAR_button & BUTTON_STOP) == BUTTON_STOP);
}

/* #[<ENTRY_FUNC>]# eButton_isEXITButton
 * name:         eButton_isEXITButton
 * global_name:  tButtonBody_eButton_isEXITButton
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isEXITButton()
{
    return ((VAR_button & BUTTON_EXIT) == BUTTON_EXIT);
}

/* #[<ENTRY_FUNC>]# eButton_isENTERButtonOnly
 * name:         eButton_isENTERButtonOnly
 * global_name:  tButtonBody_eButton_isENTERButtonOnly
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isENTERButtonOnly()
{
    return (VAR_button == BUTTON_ENTER);
}

/* #[<ENTRY_FUNC>]# eButton_isRUNButtonOnly
 * name:         eButton_isRUNButtonOnly
 * global_name:  tButtonBody_eButton_isRUNButtonOnly
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isRUNButtonOnly()
{
    return (VAR_button == BUTTON_RUN);
}

/* #[<ENTRY_FUNC>]# eButton_isSTOPButtonOnly
 * name:         eButton_isSTOPButtonOnly
 * global_name:  tButtonBody_eButton_isSTOPButtonOnly
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isSTOPButtonOnly()
{
    return (VAR_button == BUTTON_STOP);
}

/* #[<ENTRY_FUNC>]# eButton_isEXITButtonOnly
 * name:         eButton_isEXITButtonOnly
 * global_name:  tButtonBody_eButton_isEXITButtonOnly
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isEXITButtonOnly()
{
    return (VAR_button == BUTTON_EXIT);
}

