/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2010-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id:
 */
/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tFlash_template.c => src/tFlash.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * startAddress     volatile uint32_t*  ATTR_startAddress
 * requestStartPage uint32_t         ATTR_requestStartPage
 * pageSize         uint32_t         ATTR_pageSize   
 * flashBase        volatile uint32_t*  ATTR_flashBase  
 * flashCommand     volatile uint32_t*  ATTR_flashCommand
 * flashStatus      volatile uint32_t*  ATTR_flashStatus
 * flashStatusRam   volatile uint32_t*  VAR_flashStatusRam
 *
 * ƤӸؿ #_TCPF_#
 * call port : cAvrPower  signature: sAvrPower context: task
 *   void           cAvrPower_powerDown( );
 *   void           cAvrPower_update( );
 *
 * #[</PREAMBLE>]# */

#include "tFlash_tecsgen.h"
#include <sil.h>

static const char requestData[] = "Jumpin' Jack Flash";

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif


/* #[<ENTRY_PORT>]# eFlash
 * entry port: eFlash
 * signature:  sFlash
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eFlash_rewriteBios
 * name:         eFlash_rewriteBios
 * global_name:  tFlash_eFlash_rewriteBios
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void eFlash_rewriteBios() __attribute__((section(".text_ram")));

void
eFlash_rewriteBios()
{
    uint32_t request[ATTR_pageSize];
    int32_t i;

    /*
     *  Flashν񤭴׵ǡ
     */
    memset(request, 0, ATTR_pageSize);
    strncpy((char *)request, requestData, ATTR_pageSize*4);

    SIL_PRE_LOC;

    /*
     *  ߶ػ
     */
    SIL_LOC_INT();

    sil_dly_nse(10*1000*1000);

    /*
     *  Flashȥ餬ޤԤ
     */
    while(!(sil_rew_mem((void *)ATTR_flashStatus) & 0x1));

    for(i = 0; i < ATTR_pageSize; i++){
        ATTR_flashBase[i] = request[i];
    }

    /*
     *  Flashȥ˽񤭴׵ȯ
     */
    sil_wrw_mem((void *)(ATTR_flashCommand),
                (0x5A000001 + (((ATTR_requestStartPage) & 0x000003FF) << 8)));

    /*
     *  ʹߤΥɤϡROM֤ƤϤʤ
     */
    while(!(sil_rew_mem((void *)VAR_flashStatusRam) & 0x1));

    sil_dly_nse(10*1000*1000);

    /*
     * AVRŸڤ
     */
    cAvrPower_powerDown();
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
