/*
 * original:lejos-osek/src/nxtvm/platform/nxt/nxt_spi.c rev.1.1.1.1
 * modified history.
 * 05/24/2012: Modifier Takuya Ishikawa
 *           : cast (uint8_t *)
 * 05/23/2011: Modifier Takuya Ishikawa
 * 05/24/2010: Modifier Takuya Ishikawa
 *           : Changed interface name to entry function name with TECS naming rule
 *           : Modified some variables to component variables
 *           : Modified some constants to component attributes
 *           : Modified data type to ITRON spec.
 * 04/17/2010: Modifider Ryosuke Takeuchi
 *           : Modified Device Interface to ITRON-SIL interface and Changed
 *             AT91SAM7.h to SIL defined include file.
 *           : Deleted UNRE chack in twi_isr_C function.
 *           : Modified Interrupt disable in nxt_spi_init.
 * ??/??/200?: Modifier Andy Shaw
 *           : see Andy Shaw notes.
 *              added spi_set_mode and nxt_spi_refresh, used spi_isr_C.
 */
/*
 * Υե tecsgen ˤƥץ졼ȤȤƼưޤ
 * ΥեԽƻѤ뤳ȤտޤƤޤ
 * tecsgen κƼ¹Ԥˤ񤭤Ƥޤᡢ̾
 *   gen/tSPIBody_template.c => src/tSPIBody.c
 * Τ褦̾, եѹƤ齤ޤ
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ǰϤޤ줿ȤԽʤǤ
 * tecsmerge ˤޡ˻Ѥޤ
 *
 * °ޥ #_CAAM_#
 * CSPin            uint32_t         ATTR_CSPin      
 * CDPin            uint32_t         ATTR_CDPin      
 * display          uint8_t*         VAR_display     
 * dirty            volatile bool_t  VAR_dirty       
 * page             volatile uint8_t  VAR_page        
 * data             volatile uint8_t*  VAR_data        
 * mode             uint8_t          VAR_mode        
 * CSPinRam         uint32_t         VAR_CSPinRam    
 * CDPinRam         uint32_t         VAR_CDPinRam    
 *
 * #[</PREAMBLE>]# */

/* ץȥѿ򤳤˽񤭤ޤ */
#include "tSPIBody_tecsgen.h"
#include "target_at91sam7s.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

#define CSPin (1 << 10)
#define CDPin (1 << 12)

static void
spi_setMode(uint8_t mode)
{
    uint32_t status;

    /* nothing to do if we are already in the correct mode */
    if(VAR_mode == mode){
        return;
    }

    /* Wait until all bytes have been sent */
    do{
        status = sil_rew_mem((void *)(TADR_SPI_BASE+TOFF_SPI_SR));
    } while(!(status & 0x200));
    /* Set command or data mode */
    if(mode){
        sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_SODR), CDPin);
    } else {
        sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_CODR), CDPin);
    }
    /* remember the current mode */
    VAR_mode = mode;
}

/* ؿ #_TEPF_# */
/* #[<ENTRY_PORT>]# eSPI
 * entry port: eSPI
 * signature:  sSPI
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eSPI_initialize
 * name:         eSPI_initialize
 * global_name:  tSPIBody_eSPI_initialize
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSPI_initialize()
{
#define OSC 48054805
#define SPI_BITRATE 2000000

    sil_wrw_mem((void *)(TADR_PMC_BASE+TOFF_PMC_PCER), (1 << INTNO_SPI_PID));

    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PER),  (1 << 12));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_OER),  (1 << 12));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_CODR), (1 << 12));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PDR),  (1 << 14));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_ASR),  (1 << 14));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_ODR),  (1 << 14));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_OWER), (1 << 14));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_MDDR), (1 << 14));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PUDR), (1 << 14));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_IFDR), (1 << 14));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_CODR), (1 << 14));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_IDR),  (1 << 14));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PDR),  (1 << 13));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_ASR),  (1 << 13));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_ODR),  (1 << 13));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_OWER), (1 << 13));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_MDDR), (1 << 13));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PUDR), (1 << 13));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_IFDR), (1 << 13));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_CODR), (1 << 13));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_IDR),  (1 << 13));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PDR),  (1 << 10));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_BSR),  (1 << 10));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_ODR),  (1 << 10));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_OWER), (1 << 10));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_MDDR), (1 << 10));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_PUDR), (1 << 10));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_IFDR), (1 << 10));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_CODR), (1 << 10));
    sil_wrw_mem((void *)(TADR_PIO_BASE+TOFF_PIO_IDR),  (1 << 10));

    sil_wrw_mem((void *)(TADR_SPI_BASE+TOFF_SPI_CR), SPI_SWRST);
    sil_wrw_mem((void *)(TADR_SPI_BASE+TOFF_SPI_CR), SPI_SPIEN);
    sil_wrw_mem((void *)(TADR_SPI_BASE+TOFF_SPI_MR), (SPI_MSTR | SPI_MODFDIS | 0xB<<16));

    sil_wrw_mem((void *)(TADR_SPI_BASE+TOFF_SPI_CSR2), (((OSC/SPI_BITRATE)<<8) | SPI_CPOL));

    /* Set mode to unknown */
    VAR_mode = 0xff;

    /* Set up safe dma refresh state */
    VAR_data = VAR_display = (uint8_t *)0;
    VAR_dirty = false;
    VAR_page = 0;

    sil_wrw_mem((void *)(TADR_SPI_BASE+TOFF_SPI_PTCR), PDC_TXTEN);
}

/* #[<ENTRY_FUNC>]# eSPI_write
 * name:         eSPI_write
 * global_name:  tSPIBody_eSPI_write
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSPI_write(uint32_t CD, const uint8_t* data, uint32_t nBytes)
{
    uint32_t status;
    uint32_t cd_mask = (CD ? 0x100 : 0);

    spi_setMode(CD);
    while(nBytes){
        sil_wrw_mem((void *)(TADR_SPI_BASE+TOFF_SPI_TDR), (*data | cd_mask));
        data++;
        nBytes--;
        /* Wait until byte sent */
        do{
            status = sil_rew_mem((void *)(TADR_SPI_BASE+TOFF_SPI_SR));
        } while(!(status & 0x200));

    }
}

/* #[<ENTRY_FUNC>]# eSPI_setDisplay
 * name:         eSPI_setDisplay
 * global_name:  tSPIBody_eSPI_setDisplay
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSPI_setDisplay(const uint8_t* display)
{
    /* Set the display buffer to be used for dma refresh.
     * it is really only safe to set the display once. Should probably
     * sort this out so that it is set separately from requesting a refresh
     */
    if(!VAR_display){
        VAR_display = (uint8_t *)display;
    }
}

/* #[<ENTRY_FUNC>]# eSPI_refresh
 * name:         eSPI_refresh
 * global_name:  tSPIBody_eSPI_refresh
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSPI_refresh()
{
    /* Request the start of a dma refresh of the display
     */
    // If the display is not set nothing to do.
    if(!VAR_display){
        return;
    }
    // Say we have changes
    VAR_dirty = true;
    // Start the DMA refresh
    sil_wrw_mem((void *)(TADR_SPI_BASE+TOFF_SPI_IER), SPI_ENDTX);
}

/* #[<ENTRY_PORT>]# eiInterruptBody
 * entry port: eiInterruptBody
 * signature:  siHandlerBody
 * context:    non-task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eiInterruptBody_main
 * name:         eiInterruptBody_main
 * global_name:  tSPIBody_eiInterruptBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eiInterruptBody_main()
{
    if(VAR_page == 0){
        /* Check to see if we have data to display */
        if(VAR_dirty != false){
            VAR_data = VAR_display;
            VAR_dirty = false;
        } else {
            /* No so turn things off. It will get re-set if we ever have anything
         to display
             */
            sil_wrw_mem((void *)(TADR_SPI_BASE+TOFF_SPI_IDR), SPI_ENDTX);
            return;
        }
    }
    /* Make sure we are in data mode */
    spi_setMode(1);
    /* now do the transfer. We make use of the auto-wrap function so simply
     * need to send 8*132 bytes to get back to where we started. However the
     * display buffer is structured as series of 100 byte lines, so we need to
     * get tricky. I've made the display one line longer (9 lines) and so when we
     * send the data we send 100 bytes from the actual line plus 32 padding bytes
     * (that are not actually seen), from the next line. The extra line means
     * that this is safe to do. If we can redefine the display as a 8*132 then
     * we could just use a single dma transfer (instead of 8, 132 byte ones).
     * However I'm not sure if this would be safe.
     */
    sil_wrw_mem((void *)(TADR_SPI_BASE+TOFF_SPI_TNPR), (uint32_t)VAR_data);
    sil_wrw_mem((void *)(TADR_SPI_BASE+TOFF_SPI_TNCR), 132);
    VAR_page = (VAR_page + 1) % 8;
    VAR_data += 100;
}

/* #[<POSTAMBLE>]#
 *   겼ؿ񤭤ޤ
 * #[</POSTAMBLE>]#*/
